package dev.shadowsoffire.apotheosis.adventure.boss;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.world.entity.Mob;
import net.minecraft.world.entity.player.Player;
import java.util.Optional;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.level.ServerLevelAccessor;
import net.minecraft.server.level.ServerLevel;
import dev.shadowsoffire.apotheosis.adventure.AdventureModule;
import dev.shadowsoffire.apotheosis.adventure.compat.GameStagesCompat;
import dev.shadowsoffire.placebo.reload.WeightedDynamicRegistry;
import java.util.function.Predicate;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.entity.EntityTypeTest;
import net.minecraft.world.entity.EntitySelector;
import net.minecraft.world.phys.AABB;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.level.Level;
import dev.shadowsoffire.apotheosis.Apoth;
import net.minecraft.world.level.block.entity.BlockEntityType;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import dev.shadowsoffire.placebo.block_entity.TickingBlockEntity;
import net.minecraft.world.phys.shapes.Shapes;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.phys.shapes.VoxelShape;
import dev.shadowsoffire.placebo.block_entity.TickingEntityBlock;
import net.minecraft.world.level.block.Block;

public class BossSpawnerBlock extends Block implements TickingEntityBlock
{
    private static final VoxelShape OCC_SHAPE;
    
    public BossSpawnerBlock(final BlockBehaviour.Properties properties) {
        super(properties);
    }
    
    public BlockEntity m_142194_(final BlockPos pPos, final BlockState pState) {
        return new BossSpawnerTile(pPos, pState);
    }
    
    public VoxelShape m_7952_(final BlockState pState, final BlockGetter pLevel, final BlockPos pPos) {
        return BossSpawnerBlock.OCC_SHAPE;
    }
    
    static {
        OCC_SHAPE = Shapes.m_83048_(0.0, 0.0, 0.0, 0.0, 15.99, 0.0);
    }
    
    public static class BossSpawnerTile extends BlockEntity implements TickingBlockEntity
    {
        protected DynamicHolder<ApothBoss> item;
        protected int ticks;
        
        public BossSpawnerTile(final BlockPos pos, final BlockState state) {
            super((BlockEntityType)Apoth.Tiles.BOSS_SPAWNER.get(), pos, state);
            this.item = (DynamicHolder<ApothBoss>)BossRegistry.INSTANCE.emptyHolder();
            this.ticks = 0;
        }
        
        public void serverTick(final Level pLevel, final BlockPos pPos, final BlockState pState) {
            if (this.ticks++ % 40 == 0) {
                final Optional<Player> opt = this.f_58857_.m_142425_((EntityTypeTest)EntityType.f_20532_, new AABB(this.f_58858_).m_82377_(8.0, 8.0, 8.0), EntitySelector.f_20406_).stream().findFirst();
                opt.ifPresent(player -> {
                    this.f_58857_.m_46597_(this.f_58858_, Blocks.f_50016_.m_49966_());
                    final BlockPos pos = this.f_58858_;
                    ApothBoss apothBoss;
                    if (!this.item.isBound()) {
                        apothBoss = (ApothBoss)BossRegistry.INSTANCE.getRandomItem(this.f_58857_.m_213780_(), player.m_36336_(), new Predicate[] { WeightedDynamicRegistry.IDimensional.matches(this.f_58857_), GameStagesCompat.IStaged.matches(player) });
                    }
                    else {
                        apothBoss = (ApothBoss)this.item.get();
                    }
                    final ApothBoss bossItem = apothBoss;
                    if (bossItem == null) {
                        AdventureModule.LOGGER.error("A boss spawner attempted to spawn a boss at {} in {}, but no bosses were available!", (Object)this.m_58899_(), (Object)this.f_58857_.m_46472_().m_135782_());
                    }
                    else {
                        final Mob entity = bossItem.createBoss((ServerLevelAccessor)this.f_58857_, pos, this.f_58857_.m_213780_(), player.m_36336_());
                        entity.m_6710_((LivingEntity)player);
                        entity.m_21530_();
                        ((ServerLevel)this.f_58857_).m_47205_((Entity)entity);
                    }
                });
            }
        }
        
        public void setBossItem(final DynamicHolder<ApothBoss> item) {
            this.item = item;
        }
        
        public void m_183515_(final CompoundTag tag) {
            if (this.item != null) {
                tag.m_128359_("boss_item", this.item.getId().toString());
            }
            super.m_183515_(tag);
        }
        
        public void m_142466_(final CompoundTag tag) {
            this.item = (DynamicHolder<ApothBoss>)BossRegistry.INSTANCE.holder(new ResourceLocation(tag.m_128461_("boss_item")));
            super.m_142466_(tag);
        }
    }
}
